#!/usr/bin/python3

from generation import generate_uniform
from fairdiv import Instance, Allocation
import numpy as np


##############################################################################
# Quelques constantes (que vous pouvez modifier si vous voulez...)

NB_AGENTS = 4
NB_OBJECTS = 8

AGENT_NAMES = ["Tokio", "Rio", "Berlin", "Nairobi", "Stockholm",
               "Moscou", "Helsinki", "Lisbon"]

AGENTS = AGENT_NAMES[:NB_AGENTS]
OBJECTS = ["o{}".format(x+1) for x in range(8)]

MAX_WEIGHT = 20

##############################################################################

# Ici, on crée l'instance demandée

matrix = np.array(
    [[8, 4, 6, 7, 5, 2, 0, 1],
     [8, 2, 0, 3, 13, 4, 5, 6],
     [20, 7, 0, 6, 1, 5, 2, 9],
     [0, 9, 6, 1, 13, 4, 15, 2]]
)
instance = Instance(matrix, AGENTS, OBJECTS)

# Question 1 : Affichez l'instance (utilisez la fonction print)

### À vous de jouer !


# Ici, on crée une allocation vide
allocation = Allocation(instance)

# Question 2 : Allouez les objets de la manière suivante :
# - Tokio reçoit {o1, o2}
# - Rio reçoit {o3, o4}
# - Berlin reçoit {o5, o6}
# - Nairobi reçoit {o7, o8}
# NB : pour allouer un objet, utilisez la fonction allocation.give(agent, objet)
# Par exemple : allocation.give("Tokio", "o1")


### À vous de jouer !


# Question 3 : Calculez et affichez les utilités de chaque agent
# NB : Pour récupérer le poids que donne un agent à un objet, utilisez
# la fonction instance.weight(agent, objet)
# Par exemple : instance.weight("Tokio", "o1")
# NB2 : Pour récupérer la liste des objets d'un agent, utilisez
# la fonction allocation.objects(agent)
# Par exemple : allocation.objects("Tokio")


### À vous de jouer !


# Question 4 : Quelle est l'utilité collective utilitariste de cette
# allocation ? Et l'utilité collective égalitariste ?


### À vous de jouer !


# Question 5 : Cette allocation est-elle sans envie ? Si ce n'est pas le
# cas, qui envie qui ?


### À vous de jouer !



# Question 6 : Nous allons maintenant chercher à améliorer cette allocation
# de manière *distribuée*. C'est-à-dire que les agents vont négocier entre
# eux pour s'échanger des objets. Nous nous limitons ici aux types les plus
# simples d'échanges : chaque échange implique 2 agents (a1, a2) ; a1 donne
# objet o1 à a2, en échange de quoi a2 donne à o1 un objet o2. L'échange doit
# être bénéfique pour les deux agents.
#
# Écrivez un code qui parcourt l'ensemble des couples d'agents, parcourt
# l'ensemble des échanges possibles entre ces agents jusqu'à trouver
# un échange mutuellement bénéfique. Les agents s'échangeront alors ces objets.
# NB : pour retirer un objet à un agent, vous pouvez utiliser
# allocation.take_back(agent, objet)
#
# Modifiez ensuite votre code pour que ces échanges aient lieu jusqu'à ce qu'il
# ne soit plus possible d'en trouver. À chaque échange réalisé, votre programme
# devra afficher les utilités utilitariste et égalitariste courantes.
# Affichez également le nombre d'échanges réalisés. Est-on sûr que ce nombre
# est borné ? En d'autres termes, le programme terminera-t-il dans tous les
# cas ?


### À vous de jouer !



# Question 7 : affichez la nouvelle allocation. Cette allocation est-elle
# sans envie ? Si ce n'est pas le cas, qui envie qui ?


### À vous de jouer !


# Question 8 : Recommencez le processus de négociation depuis le départ
# en choisissant un ordre différent sur les agents (par exemple, utilisez
# sorted(AGENTS) pour les trier selon l'ordre alphabétique). Cela change-t-il
# quelque chose sur les utilités et l'envie ?


### À vous de jouer !



# Nous allons maintenant passer à une autre méthode d'allocation :
# l'allocation séquentielle. Commençons par remettre notre allocation
# à zéro et à définir une séquence d'agents...
allocation = Allocation(instance)
sequence = ["Tokio", "Rio", "Berlin", "Nairobi",
            "Tokio", "Rio", "Berlin", "Nairobi"]
objets_restants = set(OBJECTS)

# Question 9 : Calculez l'allocation résultant de l'exécution de cette
# séquence. Vous pouvez afficher toutes les étapes de l'allocation
# (qui prend quoi à quel moment) si vous voulez.
# NB : voici quelques indications pour vous aider :
# - pour enlever l'objet o1 de l'ensemble des objets restants :
#   objets_restants.remove("o1")
# - pour récupérer le meilleur objet de l'ensemble des objets restants
#   selon Tokio : instance.best_obj("Tokio", objets_restants)


### À vous de jouer !


# Question 10 : Affichez l'allocation résultante. Cette allocation est-elle
# sans envie ? Si ce n'est pas le cas, qui envie qui ? Affichez également les
# utilités collectives utilitariste et égalitariste.


### À vous de jouer !


# Question 11 : Essayez avec d'autres séquences et observez les différences.


### À vous de jouer !


# Essayons maintenant quelque chose de plus systématique. Nous allons
# tester, parmi les trois séquences suivantes, de déterminer en moyenne
# laquelle est la meilleure

sequence1 = ["Tokio", "Tokio", "Rio", "Rio",
             "Berlin", "Berlin", "Nairobi", "Nairobi"]
sequence2 = ["Tokio", "Rio", "Berlin", "Nairobi",
             "Tokio", "Rio", "Berlin", "Nairobi"]
sequence3 = ["Tokio", "Rio", "Berlin", "Nairobi",
             "Nairobi", "Berlin", "Rio", "Tokio"]

# Générez n instances aléatoires (n = 1000 par exemple). Pour chaque
# instance aléatoire, calculez le résultat de l'allocation séquentielle
# pour chacune des trois séquences. Ensuite calculez pour chacune des trois
# séquences :
# - la moyenne des utilités utilitariste et égalitariste
# - le nombre de fois que ces séquences résultent en des allocations sans envie
# Laquelle vous semble la meilleure ?
# NB : pour générer une instance aléatoire :
# instance = Instance(generate_uniform(NB_AGENTS, NB_OBJECTS, MAX_WEIGHT),
#                     AGENTS, OBJECTS)


### À vous de jouer !



# Question 12 : enfin, nous allons nous intéresser à une méthode d'allocation
# encore plus centralisée. Reprenez l'instance du début du TP et utilisez
# un algorithme de recherche pour calculer une allocation sans envie
# s'il en existe une. Affichez l'allocation, et affichez également
# ses utilités utilitariste et égalitariste.


### À vous de jouer !



# Question 13 : Mêmes questions en tâchant cette fois-ci de renvoyer
# l'allocation qui maximise l'utilité utilitariste puis celle qui maximise
# l'utilité égalitariste.



### À vous de jouer !



# Question 14 : reprenez enfin les trois séquences d'agents testées ci-dessus.
# Pour chaque séquence et chaque instance générée aléatoirement, comparez
# les utilités obtenues avec la séquence aux utilités optimales.
# L'utilisation d'une séquence engendre-t-elle une grosse perte d'utilité
# en comparaison de l'utilité optimale ?


### À vous de jouer !



